// Embed FreeMind maps in PmWiki
// version 20120413
// written by Petko Yotov www.pmwiki.org/Petko

// FlashObject functions by Geoff Stearns

// plugin selection priority: 2 before 1; set to 0 to disable
var FMjava = 2;
var FMflash = 1;

// default sizes, either in %, or in pixels
var FMwidth = '100%';
var FMheight = '500';

function fm_addflash(fmdir, href, w, h, elem, i) {
  var fo = new FlashObject(fmdir+"visorFreemind.swf", "visorFreeMind"+i, w, h, 6, "#9999ff");
  fo.addVariables({
    "openUrl": "_blank",
    "maxNodeWidth":"200",
    "mainNodeShape":"elipse",
    "justMap":"false",
    "defaultToolTipWordWrap":200,
    "offsetX":"left",
    "offsetY":"top",
    "buttonsPos":"top",
    "min_alpha_buttons":20,
    "max_alpha_buttons":100,
    "scaleTooltips":"false",
    "initLoadFile": href
  });
  fo.addParams({ 
    "quality":"high", "bgcolor":"#a0a0f0"
  });
  
  var nv =  document.createElement("div");
  nv.innerHTML = fo.getHTML();
  elem.parentNode.replaceChild(nv, elem);
}

function fm_addjava(fmdir, href, w, h, elem, i) {
  var applet = '<object width="'+w+'" height="'+h+'" type="application/x-java-applet"';
  if(! (navigator.plugins && navigator.mimeTypes.length))
    applet += ' classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93" '
      + '"http://java.sun.com/update/1.5.0/jinstall-1_5_0-windows-i586.cab#Version=1,5,0,0"';
  applet += '>';
  applet += '<param name="code" value="freemind.main.FreeMindApplet.class" />';
  applet += '<param name="archive" value="'+fmdir+'freemindbrowser.jar" />';   
  applet += '<param name="type" value="application/x-java-applet;version=1.4"/><param name="scriptable" value="false"/>';
  applet += '<param name="modes" value="freemind.modes.browsemode.BrowseMode"/>';
  applet += '<param name="browsemode_initial_map" value="'+href+'"/>';
  applet += '<param name="initial_mode" value="Browse"/>';
  applet += '<param name="selection_method" value="selection_method_direct"/>';      
  
  applet += '</object>';
  
  var nv =  document.createElement("div");
  nv.innerHTML = applet;
  elem.parentNode.replaceChild(nv, elem);
}

function freemind_init() {
  var scripts = document.getElementsByTagName("script");
  var fmdir = '';
  for(var i=scripts.length-1; i>=0; i--) {
    if(! scripts[i].src.match(/freemind\.js$/)) continue;
    fmdir = scripts[i].src.replace(/freemind\.js$/, '');
    break;
  }
  if(!fmdir) return;
  var lx = document.links;
  for(var i=0; i<lx.length; i++) {
    var href = lx[i].href;
    var text = lx[i].innerText || lx[i].textContent;
    var title = lx[i].title;
    if(href.match(/\.mm$/) && text.match(/^(Attach|FreeMind\w*):/)
      && ! href.match(/action=upload/)) {
      var a = title.match(/h[:=](\d+%?)/);
      var h = (a) ? a[1] : FMheight;
      a = title.match(/w[:=](\d+%?)/);
      var w = (a) ? a[1] : FMwidth;
      var nojava = title.match(/nojava/);
      var noflash = title.match(/noflash/);
      
      var d =  document.createElement("div");
      d.id =  "fmm_"+i;
      var pN = lx[i].parentNode;
      pN.insertBefore(d, lx[i]);
      
      if((! noflash) && FMflash && FMflash > FMjava) fm_addflash(fmdir, href, w, h, d, i);
      else if((! nojava) && FMjava && navigator.javaEnabled()) fm_addjava(fmdir, href, w, h, d, i);
      else if((! noflash) && FMflash) fm_addflash(fmdir, href, w, h, d, i);
    }
  }
}
if(FMflash || FMjava) setTimeout("freemind_init()", 50);



/*
 * FlashObject embed
 * by Geoff Stearns (geoff@deconcept.com, http://www.deconcept.com/)
 *
 * v1.1.1 - 05-17-2005
 *
 * writes the embed code for a flash movie, includes plugin detection
 *
 * Usage:
 *
 *  myFlash = new FlashObject("path/to/swf.swf", "swfid", "width", "height", flashversion, "backgroundcolor");
 *  myFlash.write("objId");
 *
 * for best practices, see:
 *  http://blog.deconcept.com/2005/03/31/proper-flash-embedding-flashobject-best-practices/
 *
 */

var FlashObject = function(swf, id, w, h, ver, c) {
  this.swf = swf;
  this.id = id;
  this.width = w;
  this.height = h;
  this.version = ver;
  this.align = "middle";

  this.params = new Object();
  this.variables = new Object();

  this.redirect = "";
  this.sq = document.location.search.split("?")[1] || "";
  this.bypassTxt = "<p>Already have Macromedia Flash Player? <a href='?detectflash=false&"+ this.sq +"'>Click here if you have Flash Player "+ this.version +" installed</a>.</p>";
  
  if (c) this.color = this.addParam('bgcolor', c);
  this.addParam('quality', 'high'); // default to high
  this.doDetect = getQueryParamValue('detectflash');
}

var FOP = FlashObject.prototype;

FOP.addParam = function(name, value) { this.params[name] = value; }

// by Petko Yotov
FOP.addParams = function(arr) { for(var i in arr) this.addParam(i, arr[i]); }

FOP.getParams = function() { return this.params; }

FOP.getParam = function(name) { return this.params[name]; }

FOP.addVariable = function(name, value) { this.variables[name] = value; }

// by Petko Yotov
FOP.addVariables = function(arr) { for(var i in arr) this.addVariable(i, arr[i]); }

FOP.getVariable = function(name) { return this.variables[name]; }

FOP.getVariables = function() { return this.variables; }

FOP.getParamTags = function() {
    var paramTags = "";
    for (var param in this.getParams()) {
        paramTags += '<param name="' + param + '" value="' + this.getParam(param) + '" />';
    }
    return (paramTags == "") ? false:paramTags;
}

FOP.getHTML = function() {
    var flashHTML = "";
    if (navigator.plugins && navigator.mimeTypes.length) { // netscape plugin architecture
        flashHTML += '<embed type="application/x-shockwave-flash" src="' + this.swf + '" width="' + this.width + '" height="' + this.height + '" id="' + this.id + '" align="' + this.align + '"';
        for (var param in this.getParams()) {
            flashHTML += ' ' + param + '="' + this.getParam(param) + '"';
        }
        if (this.getVariablePairs()) {
            flashHTML += ' flashVars="' + this.getVariablePairs() + '"';
        }
        flashHTML += '></embed>';
    } else { // PC IE
        flashHTML += '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="' + this.width + '" height="' + this.height + '" name="' + this.id + '" align="' + this.align + '">';
        flashHTML += '<param name="movie" value="' + this.swf + '" />';
        if (this.getParamTags()) {
            flashHTML += this.getParamTags();
        }
        if (this.getVariablePairs() != null) {
            flashHTML += '<param name="flashVars" value="' + this.getVariablePairs() + '" />';
        }
        flashHTML += '</object>';
    }
    return flashHTML; 
}

FOP.getVariablePairs = function() {
    var variablePairs = new Array();
    for (var name in this.getVariables()) { 
      variablePairs.push(name + "=" + escape(this.getVariable(name))); 
    }
    return (variablePairs.length > 0) ? variablePairs.join("&"):false;
}

FOP.write = function(elementId) {
  if(detectFlash(this.version) || this.doDetect=='false') {
    if (elementId) {
      document.getElementById(elementId).innerHTML = this.getHTML();
    } else {
      document.write(this.getHTML());
    }
  } else {
    if (this.redirect != "") {
      document.location.replace(this.redirect);
    } else if (this.altTxt) {
      if (elementId) {
        document.getElementById(elementId).innerHTML = this.altTxt +""+ this.bypassTxt;
      } else {
        document.write(this.altTxt +""+ this.bypassTxt);
      }
    }
  }   
}

/* ---- detection functions ---- */
function getFlashVersion() {
  var flashversion = 0;
  if (navigator.plugins && navigator.mimeTypes.length) {
    var x = navigator.plugins["Shockwave Flash"];
    if(x && x.description) {
      var y = x.description;
        flashversion = y.charAt(y.indexOf('.')-1);
      var aux= y.charAt(y.indexOf('.')-2);
      if("0123456789".indexOf(aux)!=-1) flashversion=aux+flashversion;
    }
  } else {
    result = false;
      for(var i = 15; i >= 3 && result != true; i--){
        execScript('on error resume next: result = IsObject(CreateObject("ShockwaveFlash.ShockwaveFlash.'+i+'"))','VBScript');
        flashversion = i;
      }
  }
  return flashversion;
}

function detectFlash(ver) { return (getFlashVersion() >= ver) ? true:false; }

// get value of query string param
function getQueryParamValue(param) {
  var q = document.location.search || document.location.href.split("#")[1];
  if (q) {
    var detectIndex = q.indexOf(param +"=");
    var endIndex = (q.indexOf("&", detectIndex) > -1) ? q.indexOf("&", detectIndex) : q.length;
    if (q.length > 1 && detectIndex > -1) {
      return q.substring(q.indexOf("=", detectIndex)+1, endIndex);
    } else {
      return "";
    }
  }
}

/* add Array.push if needed */
if(Array.prototype.push == null){
  Array.prototype.push = function(item) { this[this.length] = item; return this.length; }
}
